#include <Xm/Xm.h>
#include <Xm/Container.h>
#include <Xm/IconG.h>
#include <stdio.h>
#include <xpm.h>

#include "getdir.h"
#include "smallicons.h"
#include "smbshare.h"

extern Widget fm_container, fm_scroll1, top_level, dir_upone;
Pixmap dir_xpm, file_xpm, lfile_xpm, ldir_xpm, sdir_xpm;
Widget *file_icons;
int old_fp = 0, first_time = 0;
extern char current_wd[120];

void ContainerResizeCB(Widget w, XtPointer client_data, XtPointer call_data)
{
  Dimension sx1, sy1, x1, y1;

  XtVaGetValues(fm_scroll1, XmNwidth, &sx1, XmNheight, &sy1, NULL);
  XtVaGetValues(fm_container, XmNwidth, &x1, XmNheight, &y1, NULL);
#ifdef DEBUG
  fprintf(stderr, "%d, %d; container: %d, %d\n", sx1, sy1, x1, y1);
#endif
  if (x1 < sx1)
    XtVaSetValues(fm_container, XmNwidth, sx1, NULL);
  if (y1 < sy1)
    XtVaSetValues(fm_container, XmNheight, sy1, NULL);
}

void clear_icon_list()
{
  register int i;

  for (i = 0; i < fileptr; i++)
    {
      XtDestroyWidget(file_icons[i]);
      free(file_icons[i]);
    }
}

void DrawFileArea()
{
  int x, adjust, num_widgets=0;
  XpmAttributes attribs;
  XmString temp_str;
  Screen *myscreen;
  Display *mydisplay;
  char thisnum[4], fullpath[120];

  if (dir_xpm == NULL) {
    mydisplay=XtDisplay(top_level);
    myscreen=XtScreen(fm_container);

    attribs.closeness=40000;
    attribs.valuemask=XpmSize | XpmCloseness;
    XpmCreatePixmapFromData(mydisplay, DefaultRootWindow(mydisplay),
			    folder_xpm, &dir_xpm, NULL, &attribs);
    attribs.closeness=40000;
    attribs.valuemask=XpmSize | XpmCloseness;
    XpmCreatePixmapFromData(mydisplay, DefaultRootWindow(mydisplay),
			    sm_file_xpm, &file_xpm, NULL, &attribs);
    attribs.closeness=40000;
    attribs.valuemask=XpmSize | XpmCloseness;
    XpmCreatePixmapFromData(mydisplay, DefaultRootWindow(mydisplay),
			    linkfile_xpm, &lfile_xpm, NULL, &attribs);
    attribs.closeness=40000;
    attribs.valuemask=XpmSize | XpmCloseness;
    XpmCreatePixmapFromData(mydisplay, DefaultRootWindow(mydisplay),
			    linkfolder_xpm, &ldir_xpm, NULL, &attribs);
    attribs.closeness=40000;
    attribs.valuemask=XpmSize | XpmCloseness;
    XpmCreatePixmapFromData(mydisplay, DefaultRootWindow(mydisplay),
			    sfolder_xpm, &sdir_xpm, NULL, &attribs);
  }

  if (strcmp(current_wd, "/") == 0)
    XtSetSensitive(dir_upone, False);
  else
    XtSetSensitive(dir_upone, True);

  if (file_icons != NULL) {
    XtUnmanageChildren(file_icons, old_fp);
    file_icons = realloc(file_icons, sizeof(Widget) * fileptr);
  }
  else
    file_icons = malloc(sizeof(Widget) * fileptr);

  old_fp = fileptr;

#ifdef DEBUG
  printf("%d\n", fileptr);
#endif
  /* First pass: display directories. */
  adjust = 0;
  for (x=0; x < fileptr; x++) {
    if (files[x].filetype < 2) {
#ifdef DEBUG
      printf("%d: %s\n", x, files[x].name);
#endif
      if ((strcmp(files[x].name, "..")==0) && (strcmp(current_wd, "/")==0)) {
	/*	adjust = 1; */
	continue;
	/* old_fp--; */
      }
      sprintf(thisnum, "%d", x);
      temp_str = XmStringCreateSimple(files[x].name);
      if (strcmp(current_wd, "/") == 0)
	sprintf(fullpath, "/%s", files[x].name);
      else
	sprintf(fullpath, "%s/%s", current_wd, files[x].name);
      if (SMB_is_shared(fullpath)) {
	file_icons[x] = XtVaCreateManagedWidget(files[x].name, 
						xmIconGadgetClass,
						fm_container,
						XmNlabelString, temp_str,
						XmNviewType, XmSMALL_ICON,
						XmNshadowThickness, 0,
						XmNsmallIconPixmap, sdir_xpm,
						/*XmNlayoutDirection, 0x86,*/
						NULL);	
	continue;
      }
      switch (files[x].filetype) {
      case 0:
      file_icons[x] = XtVaCreateManagedWidget(files[x].name, 
					      xmIconGadgetClass,
					      fm_container,
					      XmNlabelString, temp_str,
					      XmNviewType, XmSMALL_ICON,
					      XmNshadowThickness, 0,
					      XmNsmallIconPixmap, dir_xpm,
					      /*XmNlayoutDirection, 0x86,*/
					      NULL);
      break;
      case 1:
      file_icons[x] = XtVaCreateManagedWidget(files[x].name, 
					      xmIconGadgetClass,
					      fm_container,
					      XmNlabelString, temp_str,
					      XmNviewType, XmSMALL_ICON,
					      XmNshadowThickness, 0,
					      XmNsmallIconPixmap, ldir_xpm,
					      /*XmNlayoutDirection, 0x86,*/
					      NULL);
      break;
      }
      XmStringFree(temp_str);
      num_widgets++;
    }
  }
  /* Second pass: display files, links, sockets, etc. */
  for (x=0; x < fileptr; x++) {
    if (files[x].filetype > 1) {
#ifdef DEBUG
      printf("%d: %s\n", x, files[x].name);
#endif
      sprintf(thisnum, "%d", x);
      temp_str = XmStringCreateSimple(files[x].name);
      switch (files[x].filetype) {
      case 2:
      file_icons[x] = XtVaCreateManagedWidget(files[x].name, xmIconGadgetClass,
					      fm_container, 
					      XmNlabelString, temp_str,
					      XmNviewType, XmSMALL_ICON,
					      XmNshadowThickness, 0,
					      XmNsmallIconPixmap, file_xpm,
					      NULL);
      break;
      case 3:
      file_icons[x] = XtVaCreateManagedWidget(files[x].name, xmIconGadgetClass,
					      fm_container, 
					      XmNlabelString, temp_str,
					      XmNviewType, XmSMALL_ICON,
					      XmNshadowThickness, 0,
					      XmNsmallIconPixmap, lfile_xpm,
					      NULL);
      break;
      }
      XmStringFree(temp_str);
      num_widgets++;
    }
  }
  XmContainerRelayout(fm_container);
  ContainerResizeCB(NULL, NULL, NULL);
#ifdef DEBUG
  printf("Created %d widgets.\n", num_widgets);
#endif
}







